import 'dart:ffi';

import 'package:meta/meta.dart';

import 'array.dart';

@internal
abstract class DelegatingArray<T extends NativeType> implements Array<T> {
  final Array<T> _array;
  @override
  @nonVirtual
  int get length => _array.length;
  @override
  @nonVirtual
  Pointer<T> get ptr => _array.ptr;
  DelegatingArray(this._array);

  @override
  void free() {
    _array.free();
  }
}
