import 'dart:ffi';
import 'dart:ffi' as ffi;
import 'pointer.dart' as pointer;

Pointer<T> elementAt<T extends NativeType>(Pointer<T> ptr, int index,
    {required int elementSize}) {
  final address = ptr.address + index * elementSize;
  final pointer = Pointer<T>.fromAddress(address);
  return pointer;
}

int castedLength(int length,
    {required int elementSize, required int newElementSize}) {
  final lengthInBytes = pointer.lengthInBytes(length, elementSize: elementSize);
  final newLength = lengthInBytes ~/ newElementSize;
  return newLength;
}

int lengthInBytes(int length, {required int elementSize}) {
  return elementSize ~/ 8 * length;
}

extension Uint8Pointer on Pointer<Uint8> {
  int get size => ffi.sizeOf<Uint8>();
  Pointer<Uint8> elementAt(int index) =>
      pointer.elementAt(this, index, elementSize: size);
}
