import 'dart:ffi';

import 'package:meta/meta.dart';

import 'pointer.dart';

import 'array.dart';

/// Non-owning view into an [Array]
@sealed
class Slice<T extends NativeType> implements Array<T> {
  @override
  final Pointer<T> ptr;
  @override
  final int length;
  Slice.fromPtr(Pointer<T> ptr, this.length,
      {int startIndex = 0, required int elementSizeInBytes})
      : ptr = elementAt(ptr, startIndex, elementSize: elementSizeInBytes);
  Slice.fromArray(Array<T> arr, int length,
      {int startIndex = 0, required int elementSizeInBytes})
      : this.fromPtr(arr.ptr, length,
            startIndex: startIndex, elementSizeInBytes: elementSizeInBytes);
  @override
  void free() {}
}
